config = require('./demo_test_config.js');
Generators = require('./generators.js').Generators;
Semantics = require('./semantics.js').Semantics;
const fs = require('fs');
const { exec } = require("child_process");

const path = '/home/dev/code/interaction/client/src';

describe('Demo Tests', () => {
  it('apply', () => {
    const objects = config.objects;
    const s = new Semantics(config.semantics);
    const c = s.apply(objects, config.contexts);
    if (c != config.expected_semantics) {
      fs.writeFileSync(`${path}/actual.json`, JSON.stringify(c, 0, 2));
      fs.writeFileSync(`${path}/expected.json`, JSON.stringify(config.expected_semantics, 0, 2));
      /*
      exec("vimdiff ${path}/actual.json ${path}/expected.json", (error, stdout, stderr) => {
          if (error) {
              console.log(`error: ${error.message}`);
              return;
          }
          if (stderr) {
              console.log(`stderr: ${stderr}`);
              return;
          }
          console.log(`stdout: ${stdout}`);
      });
      */
    }
    expect(c).toStrictEqual(config.expected_semantics);

    const g = new Generators(config.generators);
    const strings = g.apply(objects, c);
    expect(strings).toStrictEqual(config.expected);
  });
})
