Generator = require('./generators.js').Generator;
Semantic = require('./semantics.js').Semantic;
module.exports = {
  contexts: [{"marker": "wantWhitespot", "word": "want", "action": "order", "items": {"name": "cheeseburger", "marker": "food", "word": "cheeseburger"}, "store": {"marker": "whitespot", "word": "whitespot"}}, {"marker": "wantWhitespot", "word": "want", "action": "order", "items": {"name": "fries", "marker": "food", "word": "fries"}, "store": {"marker": "whitespot", "word": "whitespot"}}],
  objects: {           newTank:
          () => { 
            return { name: 'tank1', 'id': 'tank1id' } 
          }
        ,
           newBuilding:
          () => { 
            return { name: 'building1', 'id': 'building1id' } 
          }
        ,
           },
  expected: ["order for cheeseburger from Whitespot", "order for fries from Whitespot"],
  expected_semantics: [{"marker": "wantWhitespot", "word": "want", "action": "order", "items": {"name": "cheeseburger", "marker": "food", "word": "cheeseburger"}, "store": {"marker": "whitespot", "word": "whitespot"}}, {"marker": "wantWhitespot", "word": "want", "action": "order", "items": {"name": "fries", "marker": "food", "word": "fries"}, "store": {"marker": "whitespot", "word": "whitespot"}}],
  generators: [
    new Generator( ({objects, context}) => context.marker.endsWith('Concept') && context.number > 0, ({g, context}) => `${g(context.number)} ${g(context.word)}` ),
    new Generator( ({objects, context}) => context.marker.endsWith('Concept') && !('number' in context), ({g, context}) => `${g(context.word)}` ),
    new Generator( ({objects, context}) => context.marker.endsWith('Concept') && context.number == 'all', ({g, context}) => `all ${g(context.word)}` ),
    new Generator( ({objects, context}) => context.marker == 'article' && context.gender == 'm', ({g, context}) => 'le' ),
    new Generator( ({objects, context}) => context.marker == 'article' && context.gender == 'f', ({g, context}) => 'la' ),
    new Generator( ({objects, context}) => context.isProperty && context.language == 'french', ({g, context}) => `${g({marker: 'article', gender: context.gender})} ${g(context.propertyName)} de ${g(context.object)} est ${g(context.value)}` ),
    new Generator( ({objects, context}) => context.isProperty, ({g, context}) => `the ${context.propertyName} of ${g(context.object)} is ${g(context.value)}` ),
    new Generator( ({objects, context}) => context.marker == 'number', ({g, context}) => `${g(context.value)}` ),
    new Generator( ({objects, context}) => context.marker == 'equal', ({g, context}) => `${g(context.objects[1])}` ),
    new Generator( ({objects, context}) => context.marker == 'conj', ({g, context}) => `${context.value.map( (c) => g(c) ).join('and')}` ),
    new Generator( ({objects, context}) => context.marker == 'move' && context.language == 'french', ({g, context}) => `deplacez ${g(context.thing)} vers ${g(context.place)}` ),
    new Generator( ({objects, context}) => context.marker == 'move', ({g, context}) => `move ${g(context.thing)} to ${g(context.place)}` ),
    new Generator( ({objects, context}) => context.marker == 'create', ({g, context}) => `create ${g(context.klass)}` ),
    new Generator( ({objects, context}) => context.marker == 'destroy', ({g, context}) => `destroy ${g(context.name)}` ),
    new Generator( ({objects, context}) => context.marker == 'alias' && context.language == 'french', ({g, context}) => `appellez ${g(context.thing)} ${g(context.name)}` ),
    new Generator( ({objects, context}) => context.marker == 'alias', ({g, context}) => `call ${g(context.thing)} ${g(context.name)}` ),
    new Generator( ({objects, context}) => context.marker == 'commander', ({g, context}) => 'commander' ),
    new Generator( ({objects, context}) => context.marker == 'commandeur', ({g, context}) => 'commandeur' ),
    new Generator( ({objects, context}) => context.marker == 'cia', ({g, context}) => 'CIA' ),
    new Generator( ({objects, context}) => context.marker == 'stop', ({g, context}) => `stop ${g(context.thing)}` ),
    new Generator( ({objects, context}) => context.marker == 'destroy', ({g, context}) => `destroy ${g(context.name)}` ),
    new Generator( ({objects, context}) => context.marker == 'week' && context.duration == 1, ({g, context}) => `${context.duration} week` ),
    new Generator( ({objects, context}) => context.marker == 'week' && context.duration > 1, ({g, context}) => `${context.duration} weeks` ),
    new Generator( ({objects, context}) => context.marker == 'earn', ({g, context}) => `${g(context.who)} earns ${g(context.amount)} ${g(context.units)} per ${context.period}` ),
    new Generator( ({objects, context}) => context.marker == 'worked', ({g, context}) => `${g(context.who)} worked ${ g({ marker: context.units, duration: context.duration}) }` ),
    new Generator( ({objects, context}) => context.marker == 'response', ({g, context}) => `${context.who} earned ${context.earnings} ${context.units}` ),
    new Generator( ({objects, context}) => context.marker == 'wantWhitespot', ({g, context}) => `order for ${g(context.items)} from ${g(context.store)}` ),
    new Generator( ({objects, context}) => context.marker == 'wantMcDonalds', ({g, context}) => `order for ${g(context.items)} from ${g(context.store)}` ),
    new Generator( ({objects, context}) => context.marker == 'food' && context.number > 0, ({g, context}) => `${g(context.number)} ${g(context.name)}` ),
    new Generator( ({objects, context}) => context.marker == 'food' && !('number' in context), ({g, context}) => `${g(context.name)}` ),
    new Generator( ({objects, context}) => context.marker == 'whitespot', ({g, context}) => 'Whitespot' ),
    new Generator( ({objects, context}) => context.marker == 'mcdonalds', ({g, context}) => 'McDonalds' ),
  ],
  semantics: [
    new Semantic( ({objects, context}) => context.marker == 'create'
, ({objects, context}) => { 
    if (context.klass.marker === 'tankConcept') {
      if (!objects.newTanks) {
        objects.newTanks = []
      }
      const tank = objects.newTank(context)
      if (!objects.mentioned) {
        objects.mentioned = []
      }
      objects.mentioned.push({ marker: 'tankConcept', word: tank.name, id: tank.id })
    } else if (context.klass.marker === 'buildingConcept') {
      if (!objects.newBuildings) {
        objects.newBuildings = []
      }
      const building = objects.newBuilding(context)
      if (!objects.mentioned) {
        objects.mentioned = []
      }
      objects.mentioned.push({ marker: 'buildingConcept', word: building.name, id: building.id })
    }
     } ),
    new Semantic( ({objects, context}) => context.marker == 'earn' && context.isQuery, ({objects, context}) => { 
      context.marker = 'response'; 
      var employee_record = objects.employees.find( (er) => er.name == context.who )
      let totalIncome = 0
      objects.workingTime.forEach( (wt) => {
        if (wt.name == context.who) {
          totalIncome += employee_record.earnings_per_period * wt.number_of_time_units
        }
      });
      context.earnings = totalIncome
     } ),
    new Semantic( ({objects, context}) => context.marker == 'earn', ({objects, context}) => { 
      if (! objects.employees ) {
        objects.employees = []
      }
      objects.employees.push({ name: context.who, earnings_per_period: context.amount, period: context.period, units: 'dollars' })
     } ),
    new Semantic( ({objects, context}) => context.marker == 'worked', ({objects, context}) => { 
      if (! objects.workingTime ) {
        objects.workingTime = []
      }
      objects.workingTime.push({ name: context.who, number_of_time_units: context.duration, time_units: context.units })
     } ),
    new Semantic( ({objects, context}) => context.pullFromContext
, ({objects, context}) => { 
    const object = objects.mentioned[0]
    objects.mentioned.shift()
    Object.assign(context, object)
    delete context.pullFromContext
     } ),
  ]
};